/* Definitions file for GNU Emacs running on bsd 4.3
   Copyright (C) 1985, 1986 Free Software Foundation, Inc.

This file is part of GNU Emacs.

GNU Emacs is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

GNU Emacs is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU Emacs; see the file COPYING.  If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */


/*
 *	Define symbols to identify the version of Unix this is.
 *	Define all the symbols that apply correctly.
 */

/* We give these symbols the numeric values found in <sys/param.h> to
   avoid warnings about redefined macros.  */
#ifdef NOTDEF
#ifndef BSD4_3
#define BSD4_3 1
#endif /* BSD4_3 */

#ifndef BSD
#define BSD 43
#endif /* BSD */
#endif

/* SYSTEM_TYPE should indicate the kind of system you are using.
 It sets the Lisp variable system-type.  */

#define SYSTEM_TYPE "QNX 4.3"

/* nomultiplejobs should be defined if your system's shell
 does not have "job control" (the ability to stop a program,
 run some other program, then continue the first one).  */

#define NOMULTIPLEJOBS

/* Do not use interrupt_input = 1 by default, because in QNX
   there is no SIGIO.  */

#undef INTERRUPT_INPUT

/* First pty name is /dev/ptyp0.  */

#define FIRST_PTY_LETTER 'p'

/*
 *	Define HAVE_PTYS if the system supports pty devices.
 */

#define HAVE_PTYS


/*
 *      Define HAVE_TERMIOS if the system provides POSIX-style
 *      functions and macros for terminal control.
 *
 *      Define HAVE_TERMIO if the system provides sysV-style ioctls
 *      for terminal control.
 *
 *      Do not define both.  HAVE_TERMIOS is preferred, if it is
 *      supported on your system.
 */

#define HAVE_TERMIOS
/* #define HAVE_TERMIO */
	 
/* Define this macro if system defines a type `union wait'.  */

/* #define HAVE_UNION_WAIT */
#undef HAVE_UNION_WAIT

/* Define HAVE_SOCKETS if system supports 4.2-compatible sockets.  */

#define HAVE_SOCKETS

/*
 *	Define NONSYSTEM_DIR_LIBRARY to make Emacs emulate
 *      The 4.2 opendir, etc., library functions.
 */

/* #define NONSYSTEM_DIR_LIBRARY */

/* Define this symbol if your system has the functions bcopy, etc. */

#define BSTRING
#define bzero(b, l) memset(b, 0, l)
#define bcopy(s, d, l) memcpy(d, s, l)
#define bcmp(a, b, l) memcmp(a, b, l)

/* subprocesses should be defined if you want to
   have code for asynchronous subprocesses
   (as used in M-x compile and M-x shell).
   This is generally OS dependent, and not supported
   under most USG systems. */

#define subprocesses

/* If your system uses COFF (Common Object File Format) then define the
   preprocessor symbol "COFF". */

/* #define COFF */

/* define MAIL_USE_FLOCK if the mailer uses flock
   to interlock access to /usr/spool/mail/$USER.
   The alternative is that a lock file named
   /usr/spool/mail/$USER.lock.  */

#define MAIL_USE_FLOCK

/* Define CLASH_DETECTION if you want lock files to be written
   so that Emacs can tell instantly when you try to modify
   a file that someone else has modified in his Emacs.  */

#define CLASH_DETECTION

/* We use the Berkeley (and usg5.2.2) interface to nlist.  */
/* AST - Really? */
	 
/* #define NLIST_STRUCT */

/* The file containing the kernel's symbol table is called /vmunix.  */

#define KERNEL_FILE "/vmunix"
#undef KERNEL_FILE
	 
/* The symbol in the kernel where the load average is found
   is named _avenrun.  */

#define LDAV_SYMBOL "_avenrun"
#undef LDAV_SYMBOL
	 
/* Send signals to subprocesses by "typing" special chars at them.  */

#define SIGNALS_VIA_CHARACTERS

/* We do have vfork.  */

#define HAVE_VFORK

/* Special stuff that might cause things to compile */

#ifndef MAXPATHLEN
#define MAXPATHLEN      PATH_MAX
#endif

#define ORDINARY_LINK
#define WAIT_USE_INT
#define GETPGRP_NO_ARG
#define SYSV_SYSTEM_DIR
#ifndef NSIG
#define NSIG	_SIGMAX
#endif

//#define  REL_ALLOC
//#define SYSTEM_MALLOC
//#define memory_warnings(x,y)

#define HAVE_GETLOADAVG
#define NO_LIM_DATA
#define CANNOT_UNEXEC
//#define CANNOT_DUMP
#define DONT_COPY_FLAG 0x00000001

#undef SIGIO
	 
#define _longjmp longjmp
#define WCOREDUMP(x)	0
#define wait3(x,y,z)	waitpid(-1,x,y)

#define LIBS_SYSTEM -lsocket -lunix
#undef LIB_MATH
#define LIB_MATH
#undef LIBS_DEBUG
#define LIBS_DEBUG
#define LD_SWITCH_SYSTEM -Onetx -N 512K -zp2
#define C_SWITCH_SYSTEM -Onetx -Q -w1 -zp2
#define START_FILES qnx-firstfile.o pre-crt0.o
#define OBJECTS_SYSTEM qnx-lastfile.o

/* configure get this wrong */
#undef HAVE_H_ERRNO
#undef HAVE_GETPAGESIZE

#ifdef emacs
//#define DATA_START 0
#define TEXT_START 0
#define DATA_END 0
#define TEXT_END 0

#define sbrk sys_sbrk

#include <stdlib.h>
#undef min
#undef max

void sys_abort(char *file, int line);
#define abort() sys_abort(__FILE__, __LINE__)
#endif

#define EXPLICIT_SIGN_EXTEND
//#define VIRT_ADDR_VARIES
#define NO_REMAP
#define UNEXEC qnxmap.o

#undef CRT0_DUMMIES
#undef DOT_GLOBAL_START

#undef HAVE_EUIDACCESS
#undef HAVE_LOGB

/* Fake out the directory inode check */
#define d_ino d_name[0]

#ifdef NOTDEF
/* This code goes in keyboard.c at line 46 */
#ifdef __QNX__
      if ((n_to_read = dev_ischars (input_fd)) < 0)
#else
      if ((readerr = ioctl (input_fd, FIONREAD, &n_to_read)) < 0)
#endif
#endif

/* We dont know tab expansion in QNX terminals */
#define TAB3	0

#define getloadavg(b,n) 0
#define croak(fname)	(printf ("%s not yet implemented\r\n", fname), \
						 reset_sys_modes (), exit (1))

/* Changed from 500000, which worked */
#define SYSTEM_PURESIZE_EXTRA 0

#define HAVE_ALLOCA
#define NO_ARG_ARRAY

#undef HAVE_GETHOSTNAME

/* #define HAVE_WINDOW_SYSTEM */
/* #define HAVE_FACES */
/* #define HAVE_PHOTON */
